##
##  elasticsearch-sql.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2025 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package version
%define       V_elasticsearch_sql 7.17.5.0
%define       V_elasticsearch     7.17.5

#   package information
Name:         elasticsearch-sql
Summary:      SQL Extension for ElasticSearch
URL:          https://github.com/NLPchina/elasticsearch-sql
Vendor:       NLPchina
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        PLUS
Group:        Database
License:      Apache
Version:      %{V_elasticsearch_sql}
Release:      20220826

#   list of sources
Source0:      https://github.com/NLPchina/elasticsearch-sql/releases/download/%{V_elasticsearch_sql}/elasticsearch-sql-%{V_elasticsearch_sql}.zip

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101, infozip
PreReq:       OpenPKG, openpkg >= 20160101
BuildPreReq:  elasticsearch
PreReq:       elasticsearch

%description
    This is the SQL extension for Elasticsearch.

%track
    prog elasticsearch-sql = {
        version   = %{V_elasticsearch_sql}
        url       = https://github.com/NLPchina/elasticsearch-sql/releases
        regex     = elasticsearch-sql-(__VER__)\.zip
    }

%prep
    %setup -q -T -c

%build

%install
    #   create installation hierarchy
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/lib/elasticsearch \
        $RPM_BUILD_ROOT%{l_prefix}/libexec/elasticsearch/plugins

    #   setup copy of ElasticSearch environment
    ln -s %{l_prefix}/lib/elasticsearch/* \
        $RPM_BUILD_ROOT%{l_prefix}/lib/elasticsearch/
    rm -f $RPM_BUILD_ROOT%{l_prefix}/lib/elasticsearch/plugins
    ln -s $RPM_BUILD_ROOT%{l_prefix}/libexec/elasticsearch/plugins \
        $RPM_BUILD_ROOT%{l_prefix}/lib/elasticsearch/

    #   patch SQL plugin (for version enforcement)
    mkdir elasticsearch
    (  cd elasticsearch
       unzip -x %{SOURCE0}
    ) || exit $?
    %{l_shtool} subst \
        -e 's;^\(elasticsearch\.version\)=.*;\1=%{V_elasticsearch};' \
        elasticsearch/plugin-descriptor.properties
    ( cd elasticsearch || exit $?
      mkdir parent-join-client
      cd parent-join-client
      %{l_prefix}/bin/unzip -q -x ../parent-join-client-*.jar
      %{l_shtool} subst \
          -e 's;^\(Implementation-Version:\) .*;\1 %{V_elasticsearch};' \
          -e 's;^\(X-Compile-Elasticsearch-Version:\) .*;\1 %{V_elasticsearch};' \
          META-INF/MANIFEST.MF
      cd ..
      rm -f parent-join-client-*.jar
      %{l_prefix}/bin/zip -q -r parent-join-client.jar parent-join-client
      rm -rf parent-join-client

      mkdir reindex-client
      cd reindex-client
      %{l_prefix}/bin/unzip -q -x ../reindex-client-*.jar
      %{l_shtool} subst \
          -e 's;^\(Implementation-Version:\) .*;\1 %{V_elasticsearch};' \
          -e 's;^\(X-Compile-Elasticsearch-Version:\) .*;\1 %{V_elasticsearch};' \
          META-INF/MANIFEST.MF
      cd ..
      rm -f reindex-client-*.jar
      %{l_prefix}/bin/zip -q -r reindex-client.jar reindex-client
      rm -rf reindex-client
    ) || exit $?
    ( cd elasticsearch || exit $?
      %{l_prefix}/bin/zip -q -r ../elasticsearch.zip *
    ) || exit $?

    #   install SQL plugin
    $RPM_BUILD_ROOT%{l_prefix}/lib/elasticsearch/bin/elasticsearch-plugin \
        install --verbose --batch \
        file://`pwd`/elasticsearch.zip

    #   cleanup environment
    rm -rf $RPM_BUILD_ROOT%{l_prefix}/lib/elasticsearch

    #   determine installation files
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

